<template>
  <component :is="type" v-bind="linkProps()">
    <slot />
  </component>
</template>

<script setup>
import { isExternal } from '@/utils/validate'

const props = defineProps({
  to: {
    type: [String, Object],
    required: true
  }
})

const isExt = computed(() => {
  return isExternal(props.to)
})

const type = computed(() => {
  if (isExt.value) {
    return 'a'
  }
  return 'router-link'
})

function linkProps() {
  if (isExt.value) {
    if(props.to.indexOf('?')>-1){
      let userNameSaaS = encodeURIComponent(localStorage.getItem("userName"))
      let passWordSaaS = encodeURIComponent(localStorage.getItem("passWord"))
      return {
        href: `${props.to}?userNameSaaS=${userNameSaaS}&passWordSaaS=${passWordSaaS}` ,
        target: '_blank',
        rel: 'noopener'
      }
    }else{
      return {
        href: props.to,
        target: '_blank',
        rel: 'noopener'
      }
    }
  }
  if(props.to.indexOf('?')>-1){
    let userNameSaaS = encodeURIComponent(localStorage.getItem("userName"))
    let passWordSaaS = encodeURIComponent(localStorage.getItem("passWord"))
    return {
      href: `${props.to}?userNameSaaS=${userNameSaaS}&passWordSaaS=${passWordSaaS}` ,
      target: '_blank',
    }
  }else{
    return {
      to: props.to
    }
  }
  // return {
  //   to: props.to
  // }
}
</script>
